/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.9 Professional
Automatic Program Generator
 Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 09.06.2008
Author  : F4CG
Company : F4CG
Comments: 


Chip type           : ATmega16
Program type        : Application
Clock frequency     : 12,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

// CodeVisionAVR C Compiler
// (C) 1998-2001 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATmega16


#pragma used+
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      // 16 bit access
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   // 16 bit access
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb OCDR=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb OCR0=0X3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

// Interrupt vectors definitions


// Needed by the power management functions (sleep.h)
#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm


// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+
#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

/*
CodeVisionAVR C Compiler
Prototypes for mathematical functions

Portions (C) 1998-2001 Pavel Haiduc, HP InfoTech S.R.L.
Portions (C) 2000-2001 Yuri G. Salov
*/



#pragma used+
#pragma used+

unsigned char cabs(signed char x);
unsigned int abs(int x);
unsigned long labs(long x);
float fabs(float x);
signed char cmax(signed char a,signed char b);
int max(int a,int b);
long lmax(long a,long b);
float fmax(float a,float b);
signed char cmin(signed char a,signed char b);
int min(int a,int b);
long lmin(long a,long b);
float fmin(float a,float b);
signed char csign(signed char x);
signed char sign(int x);
signed char lsign(long x);
signed char fsign(float x);
unsigned char isqrt(unsigned int x);
unsigned int lsqrt(unsigned long x);
float sqrt(float x);
float floor(float x);
float ceil(float x);
float fmod(float x,float y);
float modf(float x,float *ipart);
float ldexp(float x,int expon);
float frexp(float x,int *expon);
float exp(float x);
float log(float x);
float log10(float x);
float pow(float x,float y);
float sin(float x);
float cos(float x);
float tan(float x);
float sinh(float x);
float cosh(float x);
float tanh(float x);
float asin(float x);
float acos(float x);
float atan(float x);
float atan2(float y,float x);

#pragma used-
#pragma library math.lib




// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x1B ;PORTA
#endasm
/* LCD driver routines

  CodeVisionAVR C Compiler
  (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.

  BEFORE #include -ING THIS FILE YOU
  MUST DECLARE THE I/O ADDRESS OF THE
  DATA REGISTER OF THE PORT AT WHICH
  THE LCD IS CONNECTED!

  EXAMPLE FOR PORTB:

    #asm
        .equ __lcd_port=0x18
    #endasm
    #include <lcd.h>

*/


#pragma used+
#pragma used+

void _lcd_ready(void);
void _lcd_write_data(unsigned char data);
// write a byte to the LCD character generator or display RAM
void lcd_write_byte(unsigned char addr, unsigned char data);
// read a byte from the LCD character generator or display RAM
unsigned char lcd_read_byte(unsigned char addr);
// set the LCD display position  x=0..39 y=0..3
void lcd_gotoxy(unsigned char x, unsigned char y);
// clear the LCD
void lcd_clear(void);
void lcd_putchar(char c);
// write the string str located in SRAM to the LCD
void lcd_puts(char *str);
// write the string str located in FLASH to the LCD
void lcd_putsf(char flash *str);
// initialize the LCD controller
unsigned char lcd_init(unsigned char lcd_columns);

#pragma used-
#pragma library lcd.lib




const double P2=2*3.141592654;
const double DR=3.141592654/180;
const double K1=0.262516168343;

const unsigned days_month[12]={31,28,31,30,31,30,31,31,30,31,30,31};
 
long int hr, mins, sec, msec, Y=2009, cc = 0, M=1, day=12, C0, H=3, B5=69; 
long int J3, H3, M3;

unsigned int MM[2], HH[2];
double aA[2], aD[2];

double L5=33.15, Z, Z0, Z1, D, A5, D5, R5, T, T0, TT, T3, L0, L2, H0, H1, H2,
       M8, W8, A, B, A0, D0, A2, D1, D2, DA, DD, E, F, J, S, C, P, L, G, V, U, W, V0, V1, V2;

char delim=':';

bit st;


// Timer 0 overflow interrupt service routine
interrupt [10] void timer0_ovf_isr(void)
{
  cc++;
  if (cc>=1) {msec++; cc=0;};
    // Place your code here
}



// Declare your global variables here




void sun_info()
{ int i;
  for (i=0; i<2; i++)
  {
    lcd_gotoxy(9*i,0);
    lcd_putchar (HH[i]/10%10+0x30);
    lcd_putchar (HH[i]%10+0x30);
    lcd_putchar (':');
    lcd_putchar (MM[i]/10%10+0x30);
    lcd_putchar (MM[i]%10+0x30);
  }
}

long int Trunc (double x)
{
  double y, n;
  y = modf(x, &n);
  return (int)n;
}

int Sgn(float x)
{  
  return( x>=0 ?1:-1);
}

void Calendar(void)
{
  G = 1;
  if (Y < 1583) {G = 0;};
  D1 = Trunc(D);
  F = D - D1 - 0.5;
  J = -Trunc(7 * (Trunc((M + 9) / 12) + Y) / 4);
  if (G == 1)
  {
    S = Sgn(M - 9);
    A = abs(M - 9);
    J3 = Trunc(Y + S * Trunc(A / 7));
    J3 = -(((J3 / 100) + 1) * 3 / 4);
  }
  J = J + Trunc(275 * M / 9) + D1 + G * J3;
  J = J + 1721027 + 2 * G + 367 * Y;
  if (F >= 0) {goto end;};
  F = F + 1;
  J = J - 1;
end:
}

void GetTimeZone(void)
{
  T0 = T / 36525;
  S = 24110.5 + 8640184.813 * T0;
  S = S + 86636.6 * Z0 + 86400 * L5;
  S = S / 86400;
  S = S - Trunc(S);
  T0 = S * 360 * DR;
}

void PosOfSun(void)
{

  //       
  //  (Van Flandern & Pulkkinen, 1979)
  L = 0.779072 + 0.00273790931 * T;
  G = 0.993126 + 0.0027377785 * T;
  L = L - Trunc(L);
  G = G - Trunc(G);
  L = L * P2;
  G = G * P2;
  V = 0.39785 * sin(L);
  V = V - 0.01000 * sin(L - G);
  V = V + 0.00333 * sin(L + G);
  V = V - 0.00021 * TT * sin(L);
  U = 1 - 0.03349 * cos(G);
  U = U - 0.00014 * cos(2 * L);
  U = U + 0.00008 * cos(L);
  W = -0.00010 - 0.04129 * sin(2 * L);
  W = W + 0.03211 * sin(G);
  W = W + 0.00104 * sin(2 * L - G);
  W = W - 0.00035 * sin(2 * L + G);
  W = W - 0.00008 * TT * sin(G);
  S = W / sqrt(U - V * V);
  A5 = L + atan(S / sqrt(1 - S * S));
  S = V / sqrt(U);
  D5 = atan(S / sqrt(1 - S * S));
  R5 = 1.00021 * sqrt(U);
}


void PossibleEvents(int Hour)
{
  st = 0;
  L0 = T0 + Hour * K1;
  L2 = L0 + K1;
  H0 = L0 - A0;
  H2 = L2 - A2;
  H1 = (H2 + H0) / 2; //  ,
  D1 = (D2 + D0) / 2; //   
  if (Hour <= 0) {V0 = S * sin(D0) + C * cos(D0) * cos(H0) - Z;};
  V2 = S * sin(D2) + C * cos(D2) * cos(H2) - Z;
  if (Sgn(V0) == Sgn(V2)) {goto end;};
  V1 = S * sin(D1) + C * cos(D1) * cos(H1) - Z;
  A = 2 * V2 - 4 * V1 + 2 * V0;
  B = 4 * V1 - 3 * V0 - V2;
  D = B * B - 4 * A * V0;
  if (D < 0) {goto end;};
  D = sqrt(D);
  E = (-B + D) / (2 * A);
  if ((E > 1) || (E < 0)) {E = (-B - D) / (2 * A);};
  T3 = Hour + E + 1 / 120; // 
  H3 = Trunc(T3);
  M3 = Trunc((T3 - H3) * 60);
  if ((V0 < 0) && (V2 > 0)) {HH[0]=H3; MM[0]=M3; M8 = 1; st=1;}
  if ((V0 > 0) && (V2 < 0)) {HH[1]=H3; MM[1]=M3; W8 = 1; st=0;}
end:
}


void OutInform(void)
{
 if ((M8 = 0) && (W8 = 0))
 {
    if (V2 < 0) {st=-1;}
//      ListBox.Items.Add('    ');
    if (V2 > 0) {st=1;}
//      ListBox.Items.Add('    ');
 }
  else
  {
    if (M8 == 0) {st=1;} 
//      ListBox.Items.Add('      ');
    if (W8 == 0) {st=-1;} 
//      ListBox.Items.Add('      ');
  }
}
 
void show_info(void)
{ 
  D = day;
  L5 = L5 / 360;
  Z0 = H / 24;
  Calendar();
  T = (J - 2451545) + F;
  TT = T / 36525 + 1; // TT - ,   1900.0
  GetTimeZone(); //   
  T = T + H;//Z0;
  PosOfSun(); //   
  aA[0] = A5;
  aD[0] = D5;
  T = T + 1;
  PosOfSun();
  aA[1] = A5;
  aD[1] = D5;
  if (aA[1] < aA[0]) {aA[1] = aA[1] + P2;}
  Z1 = DR * 90.833; //  
  S = sin(B5 * DR);
  C = cos(B5 * DR);
  Z = cos(Z1);
  M8 = 0;
  W8 = 0;
  A0 = aA[0];
  D0 = aD[0];
  DA = aA[1] - aA[0];
  DD = aD[1] - aD[0];
  for (C0 = 0; C0 < 24; C0++)
  {
    P = (C0 + 1) / 24;
    A2 = aA[0] + P * DA;
    D2 = aD[0] + P * DD;
    PossibleEvents(C0);
    if (st != 0) {sun_info();}
    A0 = A2;
    D0 = D2;
    V0 = V2;
  }
  OutInform();

//  ListBox.Items.Add(''); //  
  if (st==0) {PORTC.0=1;;} else
  if (st==1) {PORTC.0=0;;}
}

void clock(void)
{
  if (msec>=1) 
  {
    msec=0; sec++; 
    if (delim==':') {delim=' ';} 
    else {delim=':';};
  }; 
  // if (cc==150) {msec++; cc=0;};
 // if (msec==100) {msec=0; sec++;};
 //if (sec==60) {sec=0; mins++;};
 // if (mins==60) {mins=0; hr++;};
 // if (hr==24) {day++; hr=0;};
 // if (day==days_month[m]) {m++; day=1;};
  
  
  if (sec==1) {sec=0; mins++;};
  if (mins==1) {mins=0; hr++;};
  if (hr==24) {day++; hr=0;};
  if (day==days_month[M-1]) {M++; day=1;};
  if (M==12) {M=0; Y++;};
  lcd_gotoxy(0,1);
  lcd_putchar (hr/10%10+0x30);
  lcd_putchar (hr%10+0x30);
  lcd_putchar (delim);
  lcd_putchar (mins/10%10+0x30);
  lcd_putchar (mins%10+0x30);
//        lcd_putsf (":");
//          lcd_putchar ((msec/10)%10+0x30);
//           lcd_putchar (msec%10+0x30);
  lcd_putsf (" ");
  lcd_putchar ((day/10)%10+0x30);
  lcd_putchar (day%10+0x30);
  lcd_putsf ("/");
  lcd_putchar ((M/10)%10+0x30);
  lcd_putchar (M%10+0x30);
  lcd_putsf ("/");
  lcd_putchar ((Y/1000)%10+0x30);
  lcd_putchar ((Y/100)%10+0x30);
  lcd_putchar ((Y/10)%10+0x30);
  lcd_putchar (Y%10+0x30);
  if ((hr>HH[0]) && (mins>MM[0])) {st=0;}
  if ((hr>HH[1]) && (mins>MM[1])) {st=1;}
 }


void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port A initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=In Func2=Out Func1=Out Func0=Out 
// State7=0 State6=0 State5=0 State4=0 State3=T State2=0 State1=0 State0=0 
PORTA=0x00;
DDRA=0xF7;

// Port B initialization
// Func7=In Func6=In Func5=In Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=T State6=T State5=T State4=1 State3=1 State2=1 State1=1 State0=1 
PORTB=0x1F;
DDRB=0x1F;

// Port C initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=Out 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=0 
PORTC=0x00;
DDRC=0x01;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x00;


// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 1000,000 kHz
// Mode: Normal top=FFh
// OC0 output: Disconnected
TCCR0=0x02;
TCNT0=0x00;
OCR0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// INT2: Off
MCUCR=0x00;
MCUCSR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x01;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// LCD module initialization
lcd_init(16);

// Global enable interrupts
//#asm("sei")

while (1)
      {
      // Place your code here
          clock();
          show_info();
      };
}
