#line 1 "D:/Radio/Labcenter Electronics/Proteus 7 Professional/SAMPLES/VSM for AVR/  /Auto_Light.c"
#line 1 "d:/radio/mikroelektronika/mikroc pro for avr/include/math.h"
#line 31 "D:/Radio/Labcenter Electronics/Proteus 7 Professional/SAMPLES/VSM for AVR/  /Auto_Light.c"
 .equ __lcd_port=0x1B ;PORTA






const double P2=2*PI;
const double DR=PI/180;
const double K1=0.262516168343;

const unsigned days_month[12]={31,28,31,30,31,30,31,31,30,31,30,31};

unsigned long int hr, mins, sec, msec, Y=2008, cc = 0, M=2, day=14, C0, H=3, B5=69;
long int J3, H3, M3;

unsigned int MM[2], HH[2];
float aA[2], aD[2];

float L5=32, Z, Z0, Z1, D, A5, D5, R5, T, T0, TT, T3, L0, L2, H0, H1, H2,
 M8, W8, A, B, A0, D0, A2, D1, D2, DA, DD, E, F, J, S, C, P, L, G, V, U, W, V0, V1, V2;

char delim=':';

bit st;



interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
 cc++;
 if (cc>=1) {msec++; cc=0;};

}








void sun_info()
{ int i;
 for (i=0; i<2; i++)
 {
 lcd_gotoxy(9*i,0);
 lcd_putchar (HH[i]/10%10+0x30);
 lcd_putchar (HH[i]%10+0x30);
 lcd_putchar (':');
 lcd_putchar (MM[i]/10%10+0x30);
 lcd_putchar (MM[i]%10+0x30);
 }
}

int Sgn(float x)
{
 return( x>=0 ?1:-1);
}

void Calendar(void)
{
 G = 1;
 if (Y < 1583) {G = 0;};
 D1 = (int)(D);
 F = D - D1 - 0.5;
 J = -(int)(7 * ((int)((M + 9) / 12) + Y) / 4);
 if (G == 1)
 {
 S = Sgn(M - 9);
 A = abs(M - 9);
 J3 = (int)(Y + S * (int)(A / 7));
 J3 = -(long int)(((long int)(J3 / 100) + 1) * 3 / 4);
 }
 J = J + (int)(275 * M / 9) + D1 + G * J3;
 J = J + 1721027 + 2 * G + 367 * Y;
 if (F >= 0) {goto end;};
 F = F + 1;
 J = J - 1;
end:
}

void GetTimeZone(void)
{
 T0 = T / 36525;
 S = 24110.5 + 8640184.813 * T0;
 S = S + 86636.6 * Z0 + 86400 * L5;
 S = S / 86400;
 S = S - (int)(S);
 T0 = S * 360 * DR;
}

void PosOfSun(void)
{



 L = 0.779072 + 0.00273790931 * T;
 G = 0.993126 + 0.0027377785 * T;
 L = L - (int)(L);
 G = G - (int)(G);
 L = L * P2;
 G = G * P2;
 V = 0.39785 * sin(L);
 V = V - 0.01000 * sin(L - G);
 V = V + 0.00333 * sin(L + G);
 V = V - 0.00021 * TT * sin(L);
 U = 1 - 0.03349 * cos(G);
 U = U - 0.00014 * cos(2 * L);
 U = U + 0.00008 * cos(L);
 W = -0.00010 - 0.04129 * sin(2 * L);
 W = W + 0.03211 * sin(G);
 W = W + 0.00104 * sin(2 * L - G);
 W = W - 0.00035 * sin(2 * L + G);
 W = W - 0.00008 * TT * sin(G);
 S = W / sqrt(U - V * V);
 A5 = L + atan(S / sqrt(1 - S * S));
 S = V / sqrt(U);
 D5 = atan(S / sqrt(1 - S * S));
 R5 = 1.00021 * sqrt(U);
}


void PossibleEvents(int Hour)
{
 st = 0;
 L0 = T0 + Hour * K1;
 L2 = L0 + K1;
 H0 = L0 - A0;
 H2 = L2 - A2;
 H1 = (H2 + H0) / 2;
 D1 = (D2 + D0) / 2;
 if (Hour <= 0) {V0 = S * sin(D0) + C * cos(D0) * cos(H0) - Z;};
 V2 = S * sin(D2) + C * cos(D2) * cos(H2) - Z;
 if (Sgn(V0) == Sgn(V2)) {goto end;};
 V1 = S * sin(D1) + C * cos(D1) * cos(H1) - Z;
 A = 2 * V2 - 4 * V1 + 2 * V0;
 B = 4 * V1 - 3 * V0 - V2;
 D = B * B - 4 * A * V0;
 if (D < 0) {goto end;};
 D = sqrt(D);
 E = (-B + D) / (2 * A);
 if ((E > 1) || (E < 0)) {E = (-B - D) / (2 * A);};
 T3 = Hour + E + 1 / 120;
 H3 = (int)(T3);
 M3 = (int)((T3 - H3) * 60);
 if ((V0 < 0) && (V2 > 0)) {HH[0]=H3; MM[0]=M3; M8 = 1; st=1;}
 if ((V0 > 0) && (V2 < 0)) {HH[1]=H3; MM[1]=M3; W8 = 1; st=0;}
end:
}


void OutInform(void)
{
 if ((M8 = 0) && (W8 = 0))
 {
 if (V2 < 0) {st=-1;}

 if (V2 > 0) {st=1;}

 }
 else
 {
 if (M8 == 0) {st=1;}

 if (W8 == 0) {st=-1;}

 }
}

void show_info(void)
{
 D = (int)day;


 L5 = L5 / 360;
 Z0 = H / 24;
 Calendar();
 T = (J - 2451545) + F;
 TT = T / 36525 + 1;
 GetTimeZone();
 T = T + Z0;
 PosOfSun();
 aA[1] = A5;
 aD[1] = D5;
 T = T + 1;
 PosOfSun();
 aA[1] = A5;
 aD[1] = D5;
 if (aA[1] < aA[0]) {aA[1] = aA[1] + P2;};
 Z1 = DR * 90.833;
 S = sin(B5 * DR);
 C = cos(B5 * DR);
 Z = cos(Z1);
 M8 = 0;
 W8 = 0;
 A0 = aA[0];
 D0 = aD[0];
 DA = aA[1] - aA[0];
 DD = aD[1] - aD[0];
 for (C0 = 0; C0<24; C0++)
 {
 P = (C0 + 1) / 24;
 A2 = aA[0] + P * DA;
 D2 = aD[0] + P * DD;
 PossibleEvents(C0);
 if (st == 1) {sun_info();};
 A0 = A2;
 D0 = D2;
 V0 = V2;
 }
 OutInform();

 if (st==0) { PORTC.0=1; ;} else
 if (st==1) { PORTC.0=0; ;}
}

void clock(void)
{
 if (msec>=1)
 {
 msec=0; sec++;
 if (delim==':') {delim=' ';}
 else {delim=':';};
 };








 if (sec==1) {sec=0; mins++;};
 if (mins==1) {mins=0; hr++;};
 if (hr==24) {day++; hr=0;};
 if (day==days_month[M-1]) {M++; day=1;};
 if (M==12) {M=0; Y++;};
 lcd_gotoxy(0,1);
 lcd_putchar (hr/10%10+0x30);
 lcd_putchar (hr%10+0x30);
 lcd_putchar (delim);
 lcd_putchar (mins/10%10+0x30);
 lcd_putchar (mins%10+0x30);



 lcd_putsf (" ");
 lcd_putchar ((day/10)%10+0x30);
 lcd_putchar (day%10+0x30);
 lcd_putsf ("/");
 lcd_putchar ((M/10)%10+0x30);
 lcd_putchar (M%10+0x30);
 lcd_putsf ("/");
 lcd_putchar ((Y/1000)%10+0x30);
 lcd_putchar ((Y/100)%10+0x30);
 lcd_putchar ((Y/10)%10+0x30);
 lcd_putchar (Y%10+0x30);
 if ((hr>HH[0]) && (mins>MM[0])) {st=0;}
 if ((hr>HH[1]) && (mins>MM[1])) {st=1;}
 }


void main(void)
{






PORTA=0x00;
DDRA=0xF7;




PORTB=0x1F;
DDRB=0x1F;




PORTC=0x00;
DDRC=0x01;




PORTD=0x00;
DDRD=0x00;







TCCR0=0x02;
TCNT0=0x00;
OCR0=0x00;
#line 345 "D:/Radio/Labcenter Electronics/Proteus 7 Professional/SAMPLES/VSM for AVR/  /Auto_Light.c"
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;






ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;





MCUCR=0x00;
MCUCSR=0x00;


TIMSK=0x01;




ACSR=0x80;
SFIOR=0x00;


lcd_init(16);




while (1)
 {

 clock();
 show_info();
 };
}
This program was produced by the
CodeWizardAVR V1.25.9 Professional
Automatic Program Generator
 Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
http:

Project :
Version :
Date : 09.06.2008
Author : F4CG
Company : F4CG
Comments:


Chip type : ATmega16
Program type : Application
Clock frequency : 12,000000 MHz
Memory model : Small
External SRAM size : 0
Data Stack size : 256
*****************************************************/
#line 1 "d:/radio/mikroelektronika/mikroc pro for avr/include/math.h"
#line 424 "D:/Radio/Labcenter Electronics/Proteus 7 Professional/SAMPLES/VSM for AVR/  /Auto_Light.c"
 .equ __lcd_port=0x1B ;PORTA






const double P2=2*PI;
const double DR=PI/180;
const double K1=0.262516168343;

const unsigned days_month[12]={31,28,31,30,31,30,31,31,30,31,30,31};

unsigned long int hr, mins, sec, msec, Y=2008, cc = 0, M=2, day=14, C0, H=3, B5=69;
long int J3, H3, M3;

unsigned int MM[2], HH[2];
float aA[2], aD[2];

float L5=32, Z, Z0, Z1, D, A5, D5, R5, T, T0, TT, T3, L0, L2, H0, H1, H2,
 M8, W8, A, B, A0, D0, A2, D1, D2, DA, DD, E, F, J, S, C, P, L, G, V, U, W, V0, V1, V2;

char delim=':';

bit st;



interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
 cc++;
 if (cc>=1) {msec++; cc=0;};

}








void sun_info()
{ int i;
 for (i=0; i<2; i++)
 {
 lcd_gotoxy(9*i,0);
 lcd_putchar (HH[i]/10%10+0x30);
 lcd_putchar (HH[i]%10+0x30);
 lcd_putchar (':');
 lcd_putchar (MM[i]/10%10+0x30);
 lcd_putchar (MM[i]%10+0x30);
 }
}

int Sgn(float x)
{
 return( x>=0 ?1:-1);
}

void Calendar(void)
{
 G = 1;
 if (Y < 1583) {G = 0;};
 D1 = (int)(D);
 F = D - D1 - 0.5;
 J = -(int)(7 * ((int)((M + 9) / 12) + Y) / 4);
 if (G == 1)
 {
 S = Sgn(M - 9);
 A = abs(M - 9);
 J3 = (int)(Y + S * (int)(A / 7));
 J3 = -(long int)(((long int)(J3 / 100) + 1) * 3 / 4);
 }
 J = J + (int)(275 * M / 9) + D1 + G * J3;
 J = J + 1721027 + 2 * G + 367 * Y;
 if (F >= 0) {goto end;};
 F = F + 1;
 J = J - 1;
end:
}

void GetTimeZone(void)
{
 T0 = T / 36525;
 S = 24110.5 + 8640184.813 * T0;
 S = S + 86636.6 * Z0 + 86400 * L5;
 S = S / 86400;
 S = S - (int)(S);
 T0 = S * 360 * DR;
}

void PosOfSun(void)
{



 L = 0.779072 + 0.00273790931 * T;
 G = 0.993126 + 0.0027377785 * T;
 L = L - (int)(L);
 G = G - (int)(G);
 L = L * P2;
 G = G * P2;
 V = 0.39785 * sin(L);
 V = V - 0.01000 * sin(L - G);
 V = V + 0.00333 * sin(L + G);
 V = V - 0.00021 * TT * sin(L);
 U = 1 - 0.03349 * cos(G);
 U = U - 0.00014 * cos(2 * L);
 U = U + 0.00008 * cos(L);
 W = -0.00010 - 0.04129 * sin(2 * L);
 W = W + 0.03211 * sin(G);
 W = W + 0.00104 * sin(2 * L - G);
 W = W - 0.00035 * sin(2 * L + G);
 W = W - 0.00008 * TT * sin(G);
 S = W / sqrt(U - V * V);
 A5 = L + atan(S / sqrt(1 - S * S));
 S = V / sqrt(U);
 D5 = atan(S / sqrt(1 - S * S));
 R5 = 1.00021 * sqrt(U);
}


void PossibleEvents(int Hour)
{
 st = 0;
 L0 = T0 + Hour * K1;
 L2 = L0 + K1;
 H0 = L0 - A0;
 H2 = L2 - A2;
 H1 = (H2 + H0) / 2;
 D1 = (D2 + D0) / 2;
 if (Hour <= 0) {V0 = S * sin(D0) + C * cos(D0) * cos(H0) - Z;};
 V2 = S * sin(D2) + C * cos(D2) * cos(H2) - Z;
 if (Sgn(V0) == Sgn(V2)) {goto end;};
 V1 = S * sin(D1) + C * cos(D1) * cos(H1) - Z;
 A = 2 * V2 - 4 * V1 + 2 * V0;
 B = 4 * V1 - 3 * V0 - V2;
 D = B * B - 4 * A * V0;
 if (D < 0) {goto end;};
 D = sqrt(D);
 E = (-B + D) / (2 * A);
 if ((E > 1) || (E < 0)) {E = (-B - D) / (2 * A);};
 T3 = Hour + E + 1 / 120;
 H3 = (int)(T3);
 M3 = (int)((T3 - H3) * 60);
 if ((V0 < 0) && (V2 > 0)) {HH[0]=H3; MM[0]=M3; M8 = 1; st=1;}
 if ((V0 > 0) && (V2 < 0)) {HH[1]=H3; MM[1]=M3; W8 = 1; st=0;}
end:
}


void OutInform(void)
{
 if ((M8 = 0) && (W8 = 0))
 {
 if (V2 < 0) {st=-1;}

 if (V2 > 0) {st=1;}

 }
 else
 {
 if (M8 == 0) {st=1;}

 if (W8 == 0) {st=-1;}

 }
}

void show_info(void)
{
 D = (int)day;


 L5 = L5 / 360;
 Z0 = H / 24;
 Calendar();
 T = (J - 2451545) + F;
 TT = T / 36525 + 1;
 GetTimeZone();
 T = T + Z0;
 PosOfSun();
 aA[1] = A5;
 aD[1] = D5;
 T = T + 1;
 PosOfSun();
 aA[1] = A5;
 aD[1] = D5;
 if (aA[1] < aA[0]) {aA[1] = aA[1] + P2;};
 Z1 = DR * 90.833;
 S = sin(B5 * DR);
 C = cos(B5 * DR);
 Z = cos(Z1);
 M8 = 0;
 W8 = 0;
 A0 = aA[0];
 D0 = aD[0];
 DA = aA[1] - aA[0];
 DD = aD[1] - aD[0];
 for (C0 = 0; C0<24; C0++)
 {
 P = (C0 + 1) / 24;
 A2 = aA[0] + P * DA;
 D2 = aD[0] + P * DD;
 PossibleEvents(C0);
 if (st == 1) {sun_info();};
 A0 = A2;
 D0 = D2;
 V0 = V2;
 }
 OutInform();

 if (st==0) { PORTC.0=1; ;} else
 if (st==1) { PORTC.0=0; ;}
}

void clock(void)
{
 if (msec>=1)
 {
 msec=0; sec++;
 if (delim==':') {delim=' ';}
 else {delim=':';};
 };








 if (sec==1) {sec=0; mins++;};
 if (mins==1) {mins=0; hr++;};
 if (hr==24) {day++; hr=0;};
 if (day==days_month[M-1]) {M++; day=1;};
 if (M==12) {M=0; Y++;};
 lcd_gotoxy(0,1);
 lcd_putchar (hr/10%10+0x30);
 lcd_putchar (hr%10+0x30);
 lcd_putchar (delim);
 lcd_putchar (mins/10%10+0x30);
 lcd_putchar (mins%10+0x30);



 lcd_putsf (" ");
 lcd_putchar ((day/10)%10+0x30);
 lcd_putchar (day%10+0x30);
 lcd_putsf ("/");
 lcd_putchar ((M/10)%10+0x30);
 lcd_putchar (M%10+0x30);
 lcd_putsf ("/");
 lcd_putchar ((Y/1000)%10+0x30);
 lcd_putchar ((Y/100)%10+0x30);
 lcd_putchar ((Y/10)%10+0x30);
 lcd_putchar (Y%10+0x30);
 if ((hr>HH[0]) && (mins>MM[0])) {st=0;}
 if ((hr>HH[1]) && (mins>MM[1])) {st=1;}
 }


void main(void)
{






PORTA=0x00;
DDRA=0xF7;




PORTB=0x1F;
DDRB=0x1F;




PORTC=0x00;
DDRC=0x01;




PORTD=0x00;
DDRD=0x00;







TCCR0=0x02;
TCNT0=0x00;
OCR0=0x00;
#line 738 "D:/Radio/Labcenter Electronics/Proteus 7 Professional/SAMPLES/VSM for AVR/  /Auto_Light.c"
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;






ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;





MCUCR=0x00;
MCUCSR=0x00;


TIMSK=0x01;




ACSR=0x80;
SFIOR=0x00;


lcd_init(16);




while (1)
 {

 clock();
 show_info();
 };
}
